
/*
------- CHANGELOG --------------------------------------------------------------

	2007-04-03  Kim A. Brandt  <kimabrandt@gmx.de>
	* 7119.user.js (excluded): Removed `excluded' file extensions variable
	for simplicity.
	(addLink): Removed some unnecessary return statements. Changed the
	text-node to only show the last part of an URL instead of the whole
	address.
	(TAGS): Using an object for holding the tags instead of both array and
	an object.
	(expression): Added . to address the current node (document.body).
*/

const TAGS =
{
	"embed": "src",
	"object": "data"
};

function main()
{
	var expression = "";
	var isFirst = true;
	for (var tag in TAGS)
	{
		if (isFirst) isFirst = false;
		else expression += " | ";
		expression += ".//" + tag + "[@" + TAGS[tag] + "]";
	}
	var elements = document.evaluate(expression, document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (elements && elements.snapshotLength > 0) for (var i=0; i<elements.snapshotLength; i++) addLink(elements.snapshotItem(i));
}

function addLink(element)
{
	var attribute = TAGS[element.tagName.toLowerCase()];
	var value = element.getAttribute(attribute);
	var a = document.createElement("a");
	a.setAttribute("href", value);
	var index = value.lastIndexOf("/");
	var name = value.substring(index + 1);
	a.appendChild(document.createTextNode(name));
	var parent = element.parentNode;
	var next = element.nextSibling;
	parent.insertBefore(document.createElement("br"), next);
	parent.insertBefore(a, next); // ADD LINK
	parent.insertBefore(document.createElement("br"), next);
}

main();
